
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

int main() {
    size_t N;
    cin >> N;
    unordered_map<size_t, int> nums;
    vector<size_t> original;
    size_t solved = 0;
    vector<size_t> line;

    for (size_t k = 0; k < N; k++) {
        size_t num;
        cin >> num;
        nums[num] = -1;
        original.push_back(num);
    }

    size_t row = 0;
    vector<size_t> curr(1);
    while (solved < nums.size()) {
        curr.clear();
        curr.resize(row + 1);
        for (size_t i = 0; i < curr.size(); ++i) {
            if (i == 0 || i == curr.size() - 1) {
                curr[i] = 1;
            } else {
                curr[i] = line[i - 1] + line[i];
            }
            if (nums.count(curr[i]) && nums[curr[i]] == -1) {
                nums[curr[i]] = row + 1;
                ++solved;
                cout << "found " << curr[i] << " on" << row + 1 << endl;
            }
            
        }
        line = move(curr);
        ++row;
    }

    for (size_t i = 0; i < N; ++i) {
        cout << nums[original[i]] << endl;
    }


    return 0;
}